﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;

namespace Encrypter
{
    public partial class MainWindow : Window
    {
        Encoding ascii = Encoding.ASCII;
        RadioButton pressed = new RadioButton();
        public MainWindow()
        {
            InitializeComponent();
            pressed.Content = "1 Способ";
        }
        private void EncryptClick(object sender, RoutedEventArgs e)
        {
            Encryptoutput.Text = Encrypt(Encryptinput.Text, Convert.ToInt32(pressed.Content.ToString().Substring(0, 1)));
            Decryptinput.Text = Encryptoutput.Text;
        }
        private void DecryptClick(object sender, RoutedEventArgs e)
        {
            Decryptoutput.Text = Decrypt(Decryptinput.Text, Convert.ToInt32(pressed.Content.ToString().Substring(0, 1)));
        }

        public string Encrypt(string input, int way)
        {
            string output = "";
            Byte[] encodedBytes;
            try
            {
                switch (way)
                {
                    case 1:
                        Dictionary<char, int> dictionarys = input.GroupBy(x => x).ToDictionary(x => x.Key, x => x.Count());
                        encodedBytes = ascii.GetBytes(input);
                        foreach (Byte b in encodedBytes)
                            output += $"{b + Convert.ToInt32(dictionarys.Where(item => item.Key == Convert.ToChar(b)).Select(item => item.Value).FirstOrDefault())}%";
                        break;
                    case 2:
                        int pos = 0;
                        encodedBytes = ascii.GetBytes(input);
                        foreach (Byte b in encodedBytes)
                        {
                            output += $"{b + pos}%";
                            pos++;
                        }
                        break;
                    case 3:
                        encodedBytes = ascii.GetBytes(input);
                        foreach (Byte b in encodedBytes)
                            output += $"{b + input.Length}%{input.Length}^?";
                        break;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ошибка шифрования. " + ex.ToString());
            }

            return output;
        }
        public string Decrypt(string input, int way)
        {
            string output = "";
            try
            {
                switch (way)
                {
                    case 1:
                        string[] mass = input.Remove(input.Length-1, 1).Split('%');

                        int[,] array = new int[mass.Length, 2];

                        for (int i = 0; i < mass.Length; i++)
                        {
                            array[i, 0] = Convert.ToInt32(mass[i]);
                            array[i, 1] = CountOfCoincidences(mass[i], mass);
                        }

                        for (int i = 0; i < mass.Length; i++)
                            output += Convert.ToChar(Convert.ToByte(array[i, 0] - array[i, 1]));

                        break;
                    case 2:
                        int pos = 0;

                        while (input.IndexOf('%') != -1)
                        {
                            byte temp = Convert.ToByte(Convert.ToInt32(input.Substring(0, input.IndexOf('%'))) - pos);
                            pos++;
                            output += Convert.ToChar(temp);
                            input = input.Remove(0, input.IndexOf('%') + 1);
                        }
                        break;
                    case 3:
                        int count = input.Count(c => c == '%');

                        while (input.IndexOf($"%{count}^?") != -1)
                        {
                            byte temp = Convert.ToByte(Convert.ToInt32(input.Substring(0, input.IndexOf($"%{count}^?"))) - count);
                            output += Convert.ToChar(temp);
                            input = input.Remove(0, input.IndexOf($"%{count}^?") + 3 + count.ToString().Length);
                        }
                        break;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ошибка расшифровки. " + ex.ToString());
            }

            return output;
        }

        public int CountOfCoincidences(string a, string[] mass)
        {
            int count = 0;
            for (int i = 0; i < mass.Length; i++)
                if (mass[i] == a)
                    count++;
            return count;
        }

        private void RadioButton_Checked(object sender, RoutedEventArgs e)
        {
            pressed = (RadioButton)sender;
        }
    }
}